enum struct Couples
{
    int iPartnerIndex;
    int iPartnerPlayerId;
    int iWeddingDate;
    int iCPExp;
    int iCPLvl;
    int iCPEarnExp;
    int iTogether;
    int iTogetherPlay;
    int iLuv;
    char szPartnerName[32];
}

static int Couples_Data_Client_ProposeTargetUserId[MAXPLAYERS+1];
static int Couples_Data_Client_ProposeSelectUserId[MAXPLAYERS+1];
static int Couples_Data_Client_ProposeSelectedTime[MAXPLAYERS+1];

Panel Couples_Panel_About;

Couples Couples_Client_Data[MAXPLAYERS+1];

void CoupleSysOnInit()
{
    RegConsoleCmd("sm_cp",      CoupleSysOnCommandCatchedCouples);
    RegConsoleCmd("sm_couples", CoupleSysOnCommandCatchedCouples);
    RegConsoleCmd("sm_propose", Command_Propose);

    CoupleSysCreateAboutMenu();
}

void CoupleSysOnClientReady(int client)
{
    if (!IsPlayerExist(client, false) || IsFakeClient(client))
        return;

    CoupleSysFetchUser(client);
}

public Action CoupleSysOnCommandCatchedCouples(int client, int args)
{
    if(!IsPlayerExist(client, false) || !gClientData[client].PID)
        return Plugin_Handled;

    CoupleSysDisplayMainMenu(client);

    return Plugin_Handled;
}

public Action Command_Propose(int client, int args)
{
    if(!IsPlayerExist(client, false) || !gClientData[client].PID)
        return Plugin_Handled;

    Couples_DisplayProposeMenu(client);

    return Plugin_Handled;
}

void CoupleSysFetchUser(int client)
{
    if (!IsPlayerExist(client, false) || IsFakeClient(client))
        return;

    // format query
    char szQuery[256];
    FormatEx(szQuery, sizeof(szQuery), "SELECT date, exp, together, luv, source_id, target_id FROM vcf_couples WHERE source_id = '%d' OR target_id = %d LIMIT 1;", gClientData[client].PID, gClientData[client].PID);

    // query
    gServerData.DBI.Query(CoupleSysFetchUserCB, szQuery, client);
}

DBCallbackGeneral(CoupleSysFetchUserCB)
{
    if(dbRs == null)
    {
        LogError("[CoupleSysFetchUserCB] -> Error: (%s)", szError);
        if(StrContains(szError, "Lost connection to MySQL", false) != -1)
        {
            DatabaseTryReconnect();
        }
        return;
    }

    if (dbRs.HasResults && dbRs.FetchRow())
    {
        gClientData[client].iWeddingDate     = dbRs.FetchInt(0);
        gClientData[client].iCPExp           = dbRs.FetchInt(1);
        gClientData[client].iTogether        = dbRs.FetchInt(2);
        gClientData[client].iLuv             = dbRs.FetchInt(3);

        // check source or target
        int iCPID = dbRs.FetchInt(4);
        if (iCPID == gClientData[client].PID)
            iCPID = dbRs.FetchInt(5);

        // set the correct value
        gClientData[client].iPartnerPlayerId = iCPID;

        int m_iPartner = FindClientByPID(iCPID);
        if (m_iPartner != -1)
        {
            gClientData[client].iPartnerIndex = m_iPartner;

            if (IsPlayerExist(m_iPartner, false))
            {
                Chat(client, "你的CP当前在游戏中哦!");
                Chat(m_iPartner, "你的CP进入了服务器, 快去和他/她贴贴吧!");
            }
        }
    }
    else
    {
        gClientData[client].iPartnerIndex    = -2;
        gClientData[client].iPartnerPlayerId = 0;
        strcopy(gClientData[client].szPartnerName, 32, "单身狗");
        return;
    }
}

void CoupleSysDisplayMainMenu(int client)
{
    Menu menu = new Menu(MenuHandler_CouplesMainMenu);

    char date[64];
    FormatTime(date, 64, "%Y.%m.%d", gClientData[client].iWeddingDate);

    if(gClientData[client].iPartnerPlayerId)
        SetMenuTitleEx(menu, "[CP]  主菜单 \n对象: %s\n日期: %s\n持久: %d天\n等级: Lv.%d(%dXP)\n共枕: %dh%dm\n好感: %d", gClientData[client].szPartnerName, date, (GetTime()-gClientData[client].iWeddingDate)/86400, gClientData[client].iCPLvl, gClientData[client].iCPExp+gClientData[client].iCPEarnExp, (gClientData[client].iTogether]+gClientData[client].iTogetherPlay)/3600, ((gClientData[client].iTogether+gClientData[client].iTogetherPlay)%3600)/60, gClientData[client].iLuv);
    else
        SetMenuTitleEx(menu, "[CP]  主菜单 \n对象: %s", gClientData[client].szPartnerName);

    AddMenuItemEx(menu, gClientData[client].iPartnerPlayerId == 0 ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED, "receive", "求婚列表");
    AddMenuItemEx(menu, gClientData[client].iPartnerPlayerId == 0 ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED, "propose", "发起求婚");
    AddMenuItemEx(menu, gClientData[client].iPartnerPlayerId != 0 ? ITEMDRAW_DEFAULT : ITEMDRAW_DISABLED, "divorce", "发起离婚");
    AddMenuItemEx(menu, ITEMDRAW_DISABLED, "ranking", "登记列表");
    AddMenuItemEx(menu, ITEMDRAW_DEFAULT, "aboutcp", "功能介绍");

    menu.Display(client, MENU_TIME_FOREVER);
}

public int MenuHandler_CouplesMainMenu(Menu menu, MenuAction action, int client, int itemNum) 
{
    switch (action)
    {
        case MenuAction_Select:
        {
            char info[32];
            menu.GetItem(itemNum, info, 32);
            if(StrEqual(info, "receive"))       Couples_DisplayProposeMenu(client);
            else if(StrEqual(info, "propose"))  Couples_DisplaySeleteMenu(client);
            else if(StrEqual(info, "divorce"))  Couples_DisplayDivorceMenu(client);
            else if(StrEqual(info, "ranking"))  DisplayMenu(Couples_Menu_Ranking, client, 0);
            else if(StrEqual(info, "aboutcp"))  Couples_Panel_About.Send(client, MenuHandler_CouplesAboutCPPanel, 15);
        }
        case MenuAction_End:    delete menu;
        case MenuAction_Cancel: if(itemNum == MenuCancel_ExitBack) Command_Menu(client, 0);
    }
}

void Couples_DisplaySeleteMenu(int client)
{
    int num = gClientData[client].iWeddingDate - GetTime();
    if(num > 0)
    {
        Chat(client, "你还处于离婚后冷却期, 需等待\x04%d\x01秒才能再次组成CP", num);
        return;
    }

    num = Couples_Data_Client_ProposeSelectedTime[client] > GetTime()+60;
    if(num > 0)
    {
        Chat(client, "请勿频繁发起请求, 请等待\x04%d\x01秒后再试", num);
        return;
    }

    Menu menu = new Menu(MenuHandler_CouplesSelectMenu);

    char m_szId[8];
    for(int target = 1; target <= MaxClients; ++target)
    {
        // Current in game                      self?               not loading?                         has partner?
        if(!IsPlayerExist(target, false) || target == client || !gClientData[client].PID || gClientData[target].iPartnerPlayerId != 0)
            continue;

        FormatEx(m_szId, 8, "%d", GetClientUserId(target));
        AddMenuItemEx(menu, ITEMDRAW_DEFAULT, m_szId, "%N", target);
    }

    if (GetMenuItemCount(menu) < 1)
    {
        Chat(client, "当前服务器内没人可以跟你组CP...");
        delete menu;
        Couples_DisplayMainMenu(client);
        return;
    }

    menu.SetTitle("[CP]  选择CP对象");
    SetMenuExitBackButton(menu, true);
    SetMenuExitButton(menu, true);
    DisplayMenu(menu, client, 0);
}

public int MenuHandler_CouplesSelectMenu(Menu menu, MenuAction action, int source, int itemNum) 
{
    switch(action)
    {
        case MenuAction_Select:
        {
            char info[32];
            menu.GetItem(itemNum, info, 32);
            
            int userid = StringToInt(info);
            int target = GetClientOfUserId(userid);

            if(!IsPlayerExist(target, false) || IsFakeClient(target) || Couples_Client_Data[target][iPartnerPlayerId] != 0)
            {
                Chat(source, "你选择的对象不满足条件...");
                Couples_DisplayMainMenu(source);
                return;
            }

            Couples_Data_Client_ProposeTargetUserId[source] = userid;
            Couples_Data_Client_ProposeSelectedTime[source] = GetTime();
            Couples_DisplayProposeMenu(target);

            Chat(source, "已将你的CP请求发送至\x0E%N", target);
        }
        case MenuAction_End:    CloseHandle(menu);
        case MenuAction_Cancel: if(itemNum == MenuCancel_ExitBack) Couples_DisplayMainMenu(source);
    }
}

void CoupleSysCreateAboutMenu()
{
    Couples_Panel_About = new Panel();

    Couples_Panel_About.DrawText("[CP]  系统说明");
    Couples_Panel_About.DrawText(" ");
    Couples_Panel_About.DrawText("组成CP需要两厢情愿, 无法单方面组CP");
    Couples_Panel_About.DrawText("发起请求之后需要对方确认才能配对");
    Couples_Panel_About.DrawText("组成CP后 14 天内不能解除");
    Couples_Panel_About.DrawText("解除CP后 14 天内不能再组");
    Couples_Panel_About.DrawText("CP能为你提供一定的加成");
    Couples_Panel_About.DrawText("按Y输入[%内容]可以发送CP频道");
    Couples_Panel_About.DrawText("还有更多的功能正在开发中...");
    Couples_Panel_About.DrawText("希望你和你的另一半玩得开心");
    Couples_Panel_About.DrawText(" ");

    Couples_Panel_About.DrawItem("返回");
}

int FindClientByPID(int pid)
{
    for(int client = 1; client <= MaxClients; ++client)
        if(IsPlayerExist(client, false) && gClientData[client].PID)
            if(gClientData[client].PID == playerid)
                return client;

    return -1;
}