
SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for vcf_adminmenu
-- ----------------------------
DROP TABLE IF EXISTS `vcf_adminmenu`;
CREATE TABLE `vcf_adminmenu`  (
  `title` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `command` text CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `modid` tinyint(4) NOT NULL
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_admins
-- ----------------------------
DROP TABLE IF EXISTS `vcf_admins`;
CREATE TABLE `vcf_admins`  (
  `pid` int(11) NOT NULL,
  `modid` tinyint(4) NOT NULL,
  `nick` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `access` tinyint(4) NOT NULL,
  `flag` varchar(32) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  INDEX `FK_MODID_MOD`(`modid`) USING BTREE,
  INDEX `FK_PID_ADMIN`(`pid`) USING BTREE,
  CONSTRAINT `FK_MODID_MOD` FOREIGN KEY (`modid`) REFERENCES `vcf_mod` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `FK_PID_ADMIN` FOREIGN KEY (`pid`) REFERENCES `vcf_users` (`pid`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_bans
-- ----------------------------
DROP TABLE IF EXISTS `vcf_bans`;
CREATE TABLE `vcf_bans`  (
  `id` int(32) NOT NULL AUTO_INCREMENT,
  `auth` char(17) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT '0',
  `name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `modid` int(11) NOT NULL,
  `serverid` int(11) NOT NULL,
  `adminauth` char(17) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT '',
  `adminname` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `bantime` int(11) NOT NULL,
  `expiretime` int(11) NOT NULL,
  `bantype` tinyint(2) NOT NULL,
  `reason` tinytext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 5 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_errorlog
-- ----------------------------
DROP TABLE IF EXISTS `vcf_errorlog`;
CREATE TABLE `vcf_errorlog`  (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `sid` int(4) NOT NULL,
  `level` smallint(2) UNSIGNED NOT NULL DEFAULT 0,
  `module` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT 'Unknown',
  `message` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT 'Unknown Error',
  `timestamp` int(11) UNSIGNED NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `log_server_id`(`sid`) USING BTREE,
  CONSTRAINT `log_server_id` FOREIGN KEY (`sid`) REFERENCES `vcf_servers` (`id`) ON DELETE RESTRICT ON UPDATE RESTRICT
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_logs
-- ----------------------------
DROP TABLE IF EXISTS `vcf_logs`;
CREATE TABLE `vcf_logs`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `admin` char(17) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT '',
  `adminnick` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `serverid` tinyint(4) NOT NULL DEFAULT 0,
  `operate` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `target` char(17) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT '',
  `targetname` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `operationtime` int(11) NOT NULL,
  `note` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 7 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_mod
-- ----------------------------
DROP TABLE IF EXISTS `vcf_mod`;
CREATE TABLE `vcf_mod`  (
  `id` tinyint(4) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 6 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_servers
-- ----------------------------
DROP TABLE IF EXISTS `vcf_servers`;
CREATE TABLE `vcf_servers`  (
  `id` int(4) NOT NULL AUTO_INCREMENT,
  `modid` tinyint(4) NOT NULL,
  `name` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT '',
  `address` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `public` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `shortname` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `invisible` int(11) NOT NULL DEFAULT 0 COMMENT '为1则不显示',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `FK_modid_Servers`(`modid`) USING BTREE,
  CONSTRAINT `FK_modid_Servers` FOREIGN KEY (`modid`) REFERENCES `vcf_mod` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE = InnoDB AUTO_INCREMENT = 4 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_sign
-- ----------------------------
DROP TABLE IF EXISTS `vcf_sign`;
CREATE TABLE `vcf_sign`  (
  `pid` int(11) NOT NULL,
  `lastsign` int(11) NOT NULL DEFAULT 0,
  `continoussign` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`pid`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_users
-- ----------------------------
DROP TABLE IF EXISTS `vcf_users`;
CREATE TABLE `vcf_users`  (
  `pid` int(11) NOT NULL AUTO_INCREMENT,
  `auth` char(17) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT '0',
  `rulehonor` tinyint(4) NOT NULL DEFAULT 50,
  `otherhonor` tinyint(4) NOT NULL DEFAULT 30,
  `steamhonor` tinyint(4) NOT NULL DEFAULT 20,
  `warningcredits` tinyint(4) NOT NULL DEFAULT 0,
  `cleardate` char(11) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL DEFAULT '0',
  `cleartimes` int(11) NOT NULL DEFAULT 0,
  `totalpurchase` decimal(6, 2) NOT NULL,
  PRIMARY KEY (`pid`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 5 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_vip
-- ----------------------------
DROP TABLE IF EXISTS `vcf_vip`;
CREATE TABLE `vcf_vip`  (
  `pid` int(11) NOT NULL,
  `modid` tinyint(4) NOT NULL,
  `viplevel` tinyint(4) NOT NULL,
  INDEX `FK_ModID_VIP`(`modid`) USING BTREE,
  CONSTRAINT `FK_ModID_VIP` FOREIGN KEY (`modid`) REFERENCES `vcf_mod` (`id`) ON DELETE NO ACTION ON UPDATE CASCADE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Table structure for vcf_viplevel
-- ----------------------------
DROP TABLE IF EXISTS `vcf_viplevel`;
CREATE TABLE `vcf_viplevel`  (
  `level` tinyint(4) NOT NULL DEFAULT 0,
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '0',
  `needpurchase` float(11, 2) NOT NULL DEFAULT 0.00,
  PRIMARY KEY (`level`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;